# Generated by Django 2.1.2 on 2018-10-27 13:55

from django.db import migrations, models
import django.db.models.deletion
import jsonfield.fields


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='ChatConversation',
            fields=[
                ('conversation_id', models.BigAutoField(primary_key=True, serialize=False)),
                ('raw_conversation_id', models.CharField(db_index=True, max_length=255)),
                ('name', models.CharField(blank=True, max_length=64, null=True)),
                ('interface_name', models.CharField(max_length=64)),
                ('last_message_time', models.DateTimeField(blank=True, null=True)),
                ('state', models.CharField(blank=True, max_length=128, null=True)),
                ('is_test', models.BooleanField(default=False)),
                ('meta', jsonfield.fields.JSONField(null=True)),
                ('context_dict', jsonfield.fields.JSONField(null=True)),
            ],
        ),
        migrations.CreateModel(
            name='ChatMessage',
            fields=[
                ('message_id', models.BigAutoField(primary_key=True, serialize=False)),
                ('type', models.TextField(choices=[('message', 'message'), ('button', 'button'), ('schedule', 'schedule'), ('event', 'event')], max_length=16)),
                ('text', models.TextField(blank=True, null=True)),
                ('is_user', models.BooleanField()),
                ('time', models.DateTimeField(db_index=True)),
                ('state', models.TextField(blank=True, max_length=128, null=True)),
                ('entities', jsonfield.fields.JSONField(null=True)),
                ('response_dict', jsonfield.fields.JSONField(null=True)),
                ('supported', models.BooleanField(default=True)),
                ('conversation', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='messages', to='botshot.ChatConversation')),
            ],
        ),
        migrations.CreateModel(
            name='ChatUser',
            fields=[
                ('user_id', models.BigAutoField(primary_key=True, serialize=False)),
                ('raw_user_id', models.CharField(db_index=True, max_length=255)),
                ('first_name', models.CharField(blank=True, max_length=64, null=True)),
                ('last_name', models.CharField(blank=True, max_length=64, null=True)),
                ('image', models.ImageField(default='images/icon_user.png', upload_to='profile_pic')),
                ('locale', models.CharField(blank=True, max_length=16, null=True)),
                ('last_message_time', models.DateTimeField(blank=True, null=True)),
                ('conversations', models.ManyToManyField(related_name='users', to='botshot.ChatConversation')),
            ],
        ),
        migrations.AddField(
            model_name='chatmessage',
            name='user',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='messages', to='botshot.ChatUser'),
        ),
    ]
